import { jsx as _jsx } from "react/jsx-runtime";
import { useRef } from 'react';
import { useLinearPrimaryTicks } from 'react-d3-utils';
import HorizontalAxis from './HorizontalAxis';
import VerticalAxis from './VerticalAxis';
export default function LinearAxis(props) {
    const { position, tickLabelFormat, scale, ...otherProps } = props;
    const axisRef = useRef(null);
    const direction = position === 'left' || position === 'right' ? 'vertical' : 'horizontal';
    const primaryTicks = useLinearPrimaryTicks(scale, direction, axisRef, {
        tickFormat: tickLabelFormat,
    });
    const AxisComponent = direction === 'vertical' ? VerticalAxis : HorizontalAxis;
    return (_jsx(AxisComponent, { scale: scale, axisRef: axisRef, primaryTicks: primaryTicks, position: position, ...otherProps }, void 0));
}
//# sourceMappingURL=LinearAxis.js.map