import { jsx as _jsx } from "react/jsx-runtime";
import { useMemo } from 'react';
import { usePlotContext } from '../contexts/plotContext';
import { toNumber } from '../utils';
import { LineSeries } from './LineSeries';
export function FunctionSeries(props) {
    const { getY, xAxis = 'x', ...otherProps } = props;
    const { axisContext: { [xAxis]: x }, plotWidth, plotHeight, } = usePlotContext();
    const step = 1;
    const data = useMemo(() => {
        const data = [];
        if (x) {
            const isHorizontal = x
                ? x.position === 'top' || x.position === 'bottom'
                : undefined;
            const end = isHorizontal ? plotWidth : plotHeight;
            const scale = x === null || x === void 0 ? void 0 : x.scale;
            for (let i = 0; i <= end; i += step) {
                const x = toNumber(scale.invert(i));
                data.push({
                    x,
                    y: getY(x),
                });
            }
            return data;
        }
        return [{ x: 0, y: 0 }];
    }, [getY, plotHeight, plotWidth, x]);
    return _jsx(LineSeries, { data: data, ...otherProps }, void 0);
}
//# sourceMappingURL=FunctionSeries.js.map