/// <reference types="react" />
import { PlotAxisContext, PlotSeriesState } from '../contexts/plotContext';
import { PlotEventsPlotActions } from '../contexts/plotController/usePlotEvents';
import { SeriesPoint } from '../types';
export interface ClosestInfo<T extends ClosestMethods> {
    point: SeriesPoint;
    label: string;
    axis: T extends 'euclidean' ? Record<'x' | 'y', PlotAxisContext> : PlotAxisContext;
}
export declare type ClosestMethods = 'x' | 'y' | 'euclidean';
export declare type ClosestInfoResult = Record<string, ClosestInfo<ClosestMethods>>;
export interface TrackingResult {
    event: MouseEvent;
    coordinates: Record<string, number>;
    clampedCoordinates: Record<string, number>;
    movement?: Record<string, number>;
    getClosest?: (method: ClosestMethods) => ClosestInfoResult;
}
export interface TrackingProps {
    plotId: string;
    plotEvents: PlotEventsPlotActions;
    stateSeries: PlotSeriesState[];
    axisContext: Record<string, PlotAxisContext>;
    plotWidth: number;
    plotHeight: number;
}
export default function Tracking({ plotId, plotEvents, stateSeries, axisContext, plotHeight, plotWidth, }: TrackingProps): JSX.Element;
