import { RefObject } from 'react';
import { TrackingResult } from '../../components/Tracking';
declare type MouseEventHandler = (result: TrackingResult) => void;
export declare type MouseEventType = 'onMouseEnter' | 'onMouseLeave' | 'onMouseDown' | 'onMouseUp' | 'onMouseMove' | 'onClick' | 'onDoubleClick' | 'onWheel';
export declare type EventsHandlers = {
    [key in MouseEventType]?: MouseEventHandler;
};
export interface PlotEventsUserActions {
    registerHandlers: (handlersRef: RefObject<EventsHandlers>) => void;
    unregisterHandlers: (handlersRef: RefObject<EventsHandlers>) => void;
}
export interface PlotEventsPlotActions {
    registerPlot: (plotId: string) => void;
    unregisterPlot: (plotId: string) => void;
    handleEvent: (plotId: string, eventType: string, eventData: unknown) => void;
}
export declare function usePlotEventsState(): {
    userActions: PlotEventsUserActions;
    plotActions: PlotEventsPlotActions;
};
export {};
