import { jsx as _jsx } from "react/jsx-runtime";
import { Rectangle } from '../components/Annotations/Rectangle';
import { useStartMoveEnd } from './useStartMoveEnd';
export function useDrawRectangle(options = {}) {
    const { horizontalAxisId = 'x', verticalAxisId = 'y', color = 'red', style, onDraw, } = options;
    const startMoveEnd = useStartMoveEnd({
        onEnd(data) {
            const x1 = startMoveEnd.start.clampedCoordinates[horizontalAxisId];
            const x2 = data.clampedCoordinates[horizontalAxisId];
            const y1 = startMoveEnd.start.clampedCoordinates[verticalAxisId];
            const y2 = data.clampedCoordinates[verticalAxisId];
            if (x1 === x2 || y1 === y2) {
                return;
            }
            onDraw === null || onDraw === void 0 ? void 0 : onDraw({ x1, x2, y1, y2 });
        },
    });
    return {
        annotations: (startMoveEnd === null || startMoveEnd === void 0 ? void 0 : startMoveEnd.end) ? (_jsx(Rectangle, { color: color, style: { fillOpacity: 0.2, stroke: color, ...style }, x1: startMoveEnd.start.clampedCoordinates[horizontalAxisId], x2: startMoveEnd.end.clampedCoordinates[horizontalAxisId], y1: startMoveEnd.start.clampedCoordinates[verticalAxisId], y2: startMoveEnd.end.clampedCoordinates[verticalAxisId] }, void 0)) : null,
    };
}
//# sourceMappingURL=useDrawRectangle.js.map