"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FunctionSeries = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const plotContext_1 = require("../contexts/plotContext");
const utils_1 = require("../utils");
const LineSeries_1 = require("./LineSeries");
function FunctionSeries(props) {
    const { getY, xAxis = 'x', ...otherProps } = props;
    const { axisContext: { [xAxis]: x }, plotWidth, plotHeight, } = (0, plotContext_1.usePlotContext)();
    const step = 1;
    const data = (0, react_1.useMemo)(() => {
        const data = [];
        if (x) {
            const isHorizontal = x
                ? x.position === 'top' || x.position === 'bottom'
                : undefined;
            const end = isHorizontal ? plotWidth : plotHeight;
            const scale = x === null || x === void 0 ? void 0 : x.scale;
            for (let i = 0; i <= end; i += step) {
                const x = (0, utils_1.toNumber)(scale.invert(i));
                data.push({
                    x,
                    y: getY(x),
                });
            }
            return data;
        }
        return [{ x: 0, y: 0 }];
    }, [getY, plotHeight, plotWidth, x]);
    return (0, jsx_runtime_1.jsx)(LineSeries_1.LineSeries, { data: data, ...otherProps }, void 0);
}
exports.FunctionSeries = FunctionSeries;
