"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlotController = exports.usePlotEventsPlotContext = exports.usePlotEvents = exports.usePlotControls = exports.usePlotOverrides = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const usePlotEvents_1 = require("./usePlotEvents");
const usePlotOverrides_1 = require("./usePlotOverrides");
const plotOverridesContext = (0, react_1.createContext)(usePlotOverrides_1.initialPlotOverridesState);
function usePlotOverrides() {
    return (0, react_1.useContext)(plotOverridesContext);
}
exports.usePlotOverrides = usePlotOverrides;
const plotControlsContext = (0, react_1.createContext)(null);
function usePlotControls() {
    const plotControls = (0, react_1.useContext)(plotControlsContext);
    if (!plotControls) {
        throw new Error('usePlotControls must be called in a child of PlotController');
    }
    return plotControls;
}
exports.usePlotControls = usePlotControls;
const plotEventsUserContext = (0, react_1.createContext)(null);
function usePlotEvents(handlers) {
    const userContext = (0, react_1.useContext)(plotEventsUserContext);
    if (!userContext) {
        throw new Error('usePlotEvents must be called in a child of PlotController');
    }
    const ref = (0, react_1.useRef)(handlers);
    (0, react_1.useEffect)(() => {
        ref.current = handlers;
    }, [handlers]);
    (0, react_1.useEffect)(() => {
        userContext.registerHandlers(ref);
        return () => userContext.unregisterHandlers(ref);
    }, [userContext]);
}
exports.usePlotEvents = usePlotEvents;
const plotEventsPlotContext = (0, react_1.createContext)(null);
function usePlotEventsPlotContext() {
    return (0, react_1.useContext)(plotEventsPlotContext);
}
exports.usePlotEventsPlotContext = usePlotEventsPlotContext;
function PlotController(props) {
    const { userActions, plotActions } = (0, usePlotEvents_1.usePlotEventsState)();
    const { overrides, controls } = (0, usePlotOverrides_1.usePlotOverridesState)();
    return ((0, jsx_runtime_1.jsx)(plotOverridesContext.Provider, { value: overrides, children: (0, jsx_runtime_1.jsx)(plotControlsContext.Provider, { value: controls, children: (0, jsx_runtime_1.jsx)(plotEventsUserContext.Provider, { value: userActions, children: (0, jsx_runtime_1.jsx)(plotEventsPlotContext.Provider, { value: plotActions, children: props.children }, void 0) }, void 0) }, void 0) }, void 0));
}
exports.PlotController = PlotController;
